var $ = function(selector) {
  return document.getElementById(selector.replace(/\#/, ''));
};

var minutes, seconds, interval;

function startTimer(mins) {
  clearInterval(interval);
  $('#timer').style.display = null;
  $('#buttons').style.display = 'none';
  minutes = mins;
  seconds = 0;
  interval = setInterval(tick, 1000);
  updateTimer();
}

function updateTimer() {
  $('#timer-contents').innerHTML = minutes + ":" + (seconds < 10 ? "0" + seconds : seconds);
}

function tick() {
  --seconds;
  if (seconds < 0) {
    seconds = 59;
    --minutes;
    if (minutes < 0) {
      return stopTimer();
    }
  }
  updateTimer();
}

function stopTimer() {
  clearInterval(interval);
  var timeoutLength = 0;
  function throb(callback) {
    if (typeof callback === 'string') {
      var str = callback;
      callback = function() {
        $('#timer-contents').innerHTML = str;
      }
    }
    setTimeout(callback, timeoutLength);
    timeoutLength += 500;
  };
  throb('');
  throb('0:00');
  throb('');
  throb('0:00');
  throb('');
  throb('0:00');
  throb('');
  throb('0:00');
  throb('');
  throb('0:00');
  throb('');
  throb(function() {
    $('#timer').style.display = 'none';
    $('#buttons').style.display = null;
  });
}

$('#custom').onclick = function() {
  startTimer(parseInt(prompt("Enter a number of minutes:"), 10) || 1);
};
